;;; fuelle-ts.ss
; im Kurs aus der Funktion nach fuelle.ss entwickelte Tiefensuche-Loesung des Container-Fuellens

; Hier die Erweiterung auf die Tiefensuche mit backtracking:
(define
  (fuelle stuecke kapazitaet container)
  (cond
    ((voll? kapazitaet container) container)
    ((null? stuecke) #f)
    ((zu-voll? kapazitaet container)
     ; 1. Änderung:
     #f)
    ; Schritt in die Tiefe: Einpacken versuchen
    ((fuelle (rest stuecke) kapazitaet (cons (first stuecke) container)))
    (else          ; Alternative, ohne das Stueck, versuchen:
     (fuelle (rest stuecke) kapazitaet container))))

;;; ----- voll? -----
; Hilfsfunktion zum Prüfen der Bedingung
(define
  (voll? kapazitaet container)
  (= kapazitaet (apply + container)))

;;; ----- zu-voll? -----
; Hilfsfunktion zum Prüfen der Bedingung
(define
  (zu-voll? kapazitaet container)
  (< kapazitaet (apply + container)))

; Tests:
(fuelle '(30 30 30 20 20 20 20 10) 80 '())
(fuelle '(30 30 30 20 20 20 20 10) 100 '())
(fuelle '(30 30 30 20 20 20 20) 100 '())
(fuelle '(30 30 30 20 20 20 20 10) 10 '())
(fuelle '(30 30 30 20 20 20 20 10) 20 '())
(fuelle '(30 30 30 20 20 20 20 10) 200 '())


